import "GaranStuff.MoorMap.ColorPicker"
-- need to create the options window
	optionsPanel=Turbine.UI.Control();
	optionsPanel:SetSize(522,564);

	optionsViewPane=Turbine.UI.Label();
	optionsViewPane:SetParent(optionsPanel);
	optionsViewPane:SetSize(optionsPanel:GetWidth()-12,optionsPanel:GetHeight()-12)

	optionsCanvas = Turbine.UI.Control()
	optionsCanvas:SetParent(optionsViewPane);
	optionsCanvas:SetSize(510,552);

	optionsCanvas.HadErrors=false;
	optionsCanvas:SetBackColor(backColor);

	optionsCanvas.OptionsCaption=Turbine.UI.Label();
	optionsCanvas.OptionsCaption:SetParent(optionsCanvas);
	optionsCanvas.OptionsCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	optionsCanvas.OptionsCaption:SetForeColor(headingsColor);
	optionsCanvas.OptionsCaption:SetSize(optionsCanvas:GetWidth(),20);
	optionsCanvas.OptionsCaption:SetPosition(0,0);
	optionsCanvas.OptionsCaption:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	optionsCanvas.OptionsCaption:SetText(Resource[language][4]..":");

	optionsCanvas.LanguageCaption=Turbine.UI.Label();
	optionsCanvas.LanguageCaption:SetParent(optionsCanvas);
	optionsCanvas.LanguageCaption:SetPosition(10,optionsCanvas.OptionsCaption:GetTop()+optionsCanvas.OptionsCaption:GetHeight()+9);
	optionsCanvas.LanguageCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.LanguageCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsCanvas.LanguageCaption:SetForeColor(fontColor);
	optionsCanvas.LanguageCaption:SetText(Resource[language][5]..":");

	optionsCanvas.LanguageList=GaranStuff.MoorMap.DropDownList();
	optionsCanvas.LanguageList:SetParent(optionsCanvas);
	optionsCanvas.LanguageList:SetPosition(optionsCanvas.LanguageCaption:GetLeft()+optionsCanvas.LanguageCaption:GetWidth()+2,optionsCanvas.LanguageCaption.GetTop()-3);
	optionsCanvas.LanguageList:SetSize(optionsCanvas:GetWidth()-(optionsCanvas.LanguageCaption:GetWidth()+optionsCanvas.LanguageCaption:GetLeft())-65,20);
	optionsCanvas.LanguageList:SetBorderColor(trimColor);
	optionsCanvas.LanguageList:SetBackColor(backColor);
	optionsCanvas.LanguageList:SetCurrentBackColor(backColor);
	optionsCanvas.LanguageList:SetDropRows(5);

	local tmpLanguage;
	for tmpLanguage in pairs(Resource) do
		optionsCanvas.LanguageList:AddItem(Resource[tmpLanguage][1],tmpLanguage);
	end

	optionsCanvas.LanguageList.SelectedIndexChanged = function ()
		optionsCanvas:SetLanguage(optionsCanvas.LanguageList:GetValue());
	end

	optionsCanvas.WorldCaption=Turbine.UI.Label();
	optionsCanvas.WorldCaption:SetParent(optionsCanvas);
	optionsCanvas.WorldCaption:SetPosition(10,optionsCanvas.LanguageCaption:GetTop()+optionsCanvas.LanguageCaption:GetHeight()+9);
	optionsCanvas.WorldCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.WorldCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsCanvas.WorldCaption:SetForeColor(fontColor);
	optionsCanvas.WorldCaption:SetText(Resource[language][149]..":");

	optionsCanvas.WorldList=GaranStuff.MoorMap.DropDownList();
	optionsCanvas.WorldList:SetParent(optionsCanvas);
	optionsCanvas.WorldList:SetPosition(optionsCanvas.WorldCaption:GetLeft()+optionsCanvas.WorldCaption:GetWidth()+2,optionsCanvas.WorldCaption.GetTop()-3);
	optionsCanvas.WorldList:SetSize(optionsCanvas:GetWidth()-(optionsCanvas.WorldCaption:GetWidth()+optionsCanvas.WorldCaption:GetLeft())-65,20);
	optionsCanvas.WorldList:SetBorderColor(trimColor);
	optionsCanvas.WorldList:SetBackColor(backColor);
	optionsCanvas.WorldList:SetCurrentBackColor(backColor);
	optionsCanvas.WorldList:SetDropRows(5);

	optionsCanvas.WorldList:AddItem("Arkenstone","Arkenstone");
	optionsCanvas.WorldList:AddItem("Brandywine","Brandywine");
	optionsCanvas.WorldList:AddItem("Crickhollow","Crickhollow");
	optionsCanvas.WorldList:AddItem("Dwarrowdelf","Dwarrowdelf");
	optionsCanvas.WorldList:AddItem("Elendilmir","Elendilmir");
	optionsCanvas.WorldList:AddItem("Firefoot","Firefoot");
	optionsCanvas.WorldList:AddItem("Gladden","Gladden");
	optionsCanvas.WorldList:AddItem("Imladris","Imladris");
	optionsCanvas.WorldList:AddItem("Landroval","Landroval");
	optionsCanvas.WorldList:AddItem("Meneldor","Meneldor");
	optionsCanvas.WorldList:AddItem("Nimrodel","Nimrodel");
	optionsCanvas.WorldList:AddItem("Riddermark","Riddermark");
	optionsCanvas.WorldList:AddItem("Silverlode","Silverlode");
	optionsCanvas.WorldList:AddItem("Vilya","Vilya");
	optionsCanvas.WorldList:AddItem("Windfola","Windfola");
	optionsCanvas.WorldList:AddItem("[DE] Anduin","_DE_Anduin");
	optionsCanvas.WorldList:AddItem("[DE] Gwaihir","_DE_Gwaihir");
	optionsCanvas.WorldList:AddItem("[DE] Maiar","_DE_Maiar");
	optionsCanvas.WorldList:AddItem("[DE] Morthond","_DE_Morthond");
	optionsCanvas.WorldList:AddItem("[DE] Vanyar","_DE_Vanyar");
	optionsCanvas.WorldList:AddItem("[DE-RP] Belegaer","_DE_RP_Belegaer");
	optionsCanvas.WorldList:AddItem("[EN] Eldar","_EN_Eldar");
	optionsCanvas.WorldList:AddItem("[EN] Evernight","_EN_Evernight");
	optionsCanvas.WorldList:AddItem("[EN] Gilrain","_EN_Gilrain");
	optionsCanvas.WorldList:AddItem("[EN] Snowbourn","_EN_Snowbourn");
	optionsCanvas.WorldList:AddItem("[EN] Withywindle","_EN_Withywindle");
	optionsCanvas.WorldList:AddItem("[EN-RP] Laurelin","_EN_RP_Laurelin");
	optionsCanvas.WorldList:AddItem("[FR] Sirannon","_FR_Sirannon");
	optionsCanvas.WorldList:AddItem("[FR-RP] Estel","_FR_RP_Estel");

	optionsCanvas.DefaultMapCaption=Turbine.UI.Label();
	optionsCanvas.DefaultMapCaption:SetParent(optionsCanvas);
	optionsCanvas.DefaultMapCaption:SetPosition(10,optionsCanvas.WorldCaption:GetTop()+optionsCanvas.WorldCaption:GetHeight()+9);
	optionsCanvas.DefaultMapCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.DefaultMapCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsCanvas.DefaultMapCaption:SetForeColor(fontColor);
	optionsCanvas.DefaultMapCaption:SetText(Resource[language][200]..":");

	optionsCanvas.DefaultMapList=GaranStuff.MoorMap.DropDownList();
	optionsCanvas.DefaultMapList:SetParent(optionsCanvas);
	optionsCanvas.DefaultMapList:SetPosition(optionsCanvas.DefaultMapCaption:GetLeft()+optionsCanvas.DefaultMapCaption:GetWidth()+2,optionsCanvas.DefaultMapCaption.GetTop()-3);
	optionsCanvas.DefaultMapList:SetSize(optionsCanvas:GetWidth()-(optionsCanvas.DefaultMapCaption:GetWidth()+optionsCanvas.DefaultMapCaption:GetLeft())-65,20);
	optionsCanvas.DefaultMapList:SetBorderColor(trimColor);
	optionsCanvas.DefaultMapList:SetBackColor(backColor);
	optionsCanvas.DefaultMapList:SetCurrentBackColor(backColor);
	optionsCanvas.DefaultMapList:SetDropRows(5);

	local tmpIndex;

	for tmpIndex=1,mapWindow.MapSelect.ListData:GetItemCount() do
		if mapInfo[mapWindow.MapSelect.ListData:GetItem(tmpIndex).DataValue][11]==1 then
			optionsCanvas.DefaultMapList:AddItem(mapWindow.MapSelect.ListData:GetItem(tmpIndex):GetText(),mapWindow.MapSelect.ListData:GetItem(tmpIndex).DataValue)
		end
	end

-- trim color
	optionsCanvas.TrimCaption=Turbine.UI.Label();
	optionsCanvas.TrimCaption:SetParent(optionsCanvas);
	optionsCanvas.TrimCaption:SetPosition(10,optionsCanvas.DefaultMapCaption:GetTop()+optionsCanvas.DefaultMapCaption:GetHeight()+9);
	optionsCanvas.TrimCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.TrimCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsCanvas.TrimCaption:SetForeColor(fontColor);
	optionsCanvas.TrimCaption:SetText(Resource[language][6]..":");
	optionsCanvas.TrimColor=GaranStuff.MoorMap.ColorPicker();
	optionsCanvas.TrimColor:SetParent(optionsCanvas);
	optionsCanvas.TrimColor:SetPosition(optionsCanvas.TrimCaption:GetLeft()+optionsCanvas.TrimCaption:GetWidth()+5,optionsCanvas.TrimCaption:GetTop()-1);
	optionsCanvas.TrimColor:SetTrimColor(trimColor);
	optionsCanvas.TrimColor:SetColor(trimColor);
	optionsCanvas.TrimColor.ColorChanged=function()
		optionsCanvas:SetTrimColor(optionsCanvas.TrimColor:GetColor());
	end

	optionsCanvas.BackCaption=Turbine.UI.Label();
	optionsCanvas.BackCaption:SetParent(optionsCanvas);
	optionsCanvas.BackCaption:SetPosition(10,optionsCanvas.TrimColor:GetTop()+optionsCanvas.TrimColor:GetHeight()+9);
	optionsCanvas.BackCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.BackCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsCanvas.BackCaption:SetForeColor(fontColor);
	optionsCanvas.BackCaption:SetText(Resource[language][7]..":");
	optionsCanvas.BackColor=GaranStuff.MoorMap.ColorPicker();
	optionsCanvas.BackColor:SetParent(optionsCanvas);
	optionsCanvas.BackColor:SetPosition(optionsCanvas.BackCaption:GetLeft()+optionsCanvas.BackCaption:GetWidth()+5,optionsCanvas.BackCaption:GetTop()-1);
	optionsCanvas.BackColor:SetTrimColor(trimColor);
	optionsCanvas.BackColor:SetColor(backColor);
	optionsCanvas.BackColor.ColorChanged=function()
		optionsCanvas:SetBackColor(optionsCanvas.BackColor:GetColor());
	end

	optionsCanvas.FontCaption=Turbine.UI.Label();
	optionsCanvas.FontCaption:SetParent(optionsCanvas);
	optionsCanvas.FontCaption:SetPosition(10,optionsCanvas.BackColor:GetTop()+optionsCanvas.BackColor:GetHeight()+9);
	optionsCanvas.FontCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.FontCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsCanvas.FontCaption:SetForeColor(fontColor);
	optionsCanvas.FontCaption:SetText(Resource[language][8]..":"); --"Font Color:");
	optionsCanvas.FontColor=GaranStuff.MoorMap.ColorPicker();
	optionsCanvas.FontColor:SetParent(optionsCanvas);
	optionsCanvas.FontColor:SetPosition(optionsCanvas.FontCaption:GetLeft()+optionsCanvas.FontCaption:GetWidth()+5,optionsCanvas.FontCaption:GetTop()-1);
	optionsCanvas.FontColor:SetTrimColor(trimColor);
	optionsCanvas.FontColor:SetColor(fontColor);
	optionsCanvas.FontColor.ColorChanged=function()
		optionsCanvas:SetFontColor(optionsCanvas.FontColor:GetColor());
	end

	optionsCanvas.HeadingsCaption=Turbine.UI.Label();
	optionsCanvas.HeadingsCaption:SetParent(optionsCanvas);
	optionsCanvas.HeadingsCaption:SetPosition(10,optionsCanvas.FontColor:GetTop()+optionsCanvas.FontColor:GetHeight()+9);
	optionsCanvas.HeadingsCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.HeadingsCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsCanvas.HeadingsCaption:SetForeColor(fontColor);
	optionsCanvas.HeadingsCaption:SetText(Resource[language][15]..":");
	optionsCanvas.HeadingsColor=GaranStuff.MoorMap.ColorPicker();
	optionsCanvas.HeadingsColor:SetParent(optionsCanvas);
	optionsCanvas.HeadingsColor:SetPosition(optionsCanvas.HeadingsCaption:GetLeft()+optionsCanvas.HeadingsCaption:GetWidth()+5,optionsCanvas.HeadingsCaption:GetTop()-1);
	optionsCanvas.HeadingsColor:SetTrimColor(trimColor);
	optionsCanvas.HeadingsColor:SetColor(headingsColor);
	optionsCanvas.HeadingsColor.ColorChanged=function()
		optionsCanvas:SetHeadingsColor(optionsCanvas.HeadingsColor:GetColor());
	end

	optionsCanvas.ListTextCaption=Turbine.UI.Label();
	optionsCanvas.ListTextCaption:SetParent(optionsCanvas);
	optionsCanvas.ListTextCaption:SetPosition(10,optionsCanvas.HeadingsColor:GetTop()+optionsCanvas.HeadingsColor:GetHeight()+9);
	optionsCanvas.ListTextCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.ListTextCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsCanvas.ListTextCaption:SetForeColor(fontColor);
	optionsCanvas.ListTextCaption:SetText(Resource[language][16]..":");
	optionsCanvas.ListTextColor=GaranStuff.MoorMap.ColorPicker();
	optionsCanvas.ListTextColor:SetParent(optionsCanvas);
	optionsCanvas.ListTextColor:SetPosition(optionsCanvas.ListTextCaption:GetLeft()+optionsCanvas.ListTextCaption:GetWidth()+5,optionsCanvas.ListTextCaption:GetTop()-1);
	optionsCanvas.ListTextColor:SetTrimColor(trimColor);
	optionsCanvas.ListTextColor:SetColor(listTextColor);
	optionsCanvas.ListTextColor.ColorChanged=function()
		optionsCanvas:SetListTextColor(optionsCanvas.ListTextColor:GetColor());
	end

	optionsCanvas.ResetColors=Turbine.UI.Lotro.Button();
	optionsCanvas.ResetColors:SetParent(optionsCanvas);
	optionsCanvas.ResetColors:SetSize(160,20);
	optionsCanvas.ResetColors:SetPosition((optionsCanvas:GetWidth()-optionsCanvas.ResetColors:GetWidth())/2,optionsCanvas.ListTextColor:GetTop()+optionsCanvas.ListTextColor:GetHeight()+9);
	optionsCanvas.ResetColors:SetText(Resource[language][9]);
	optionsCanvas.ResetColors.Click=function()
		trimColor=Turbine.UI.Color(.2,.5,.9);
		fontColor=Turbine.UI.Color(1,.9,.5);
		backColor=Turbine.UI.Color(.05,.05,.05);
		headingsColor=Turbine.UI.Color(1,1,1);
		listTextColor=Turbine.UI.Color(1,1,1);
		optionsCanvas.TrimColor:SetColor(trimColor);
		optionsCanvas.FontColor:SetColor(fontColor);
		optionsCanvas.BackColor:SetColor(backColor);
		optionsCanvas.HeadingsColor:SetColor(headingsColor);
		optionsCanvas.ListTextColor:SetColor(listTextColor);
	end

	optionsCanvas.OpacityCaption=Turbine.UI.Label();
	optionsCanvas.OpacityCaption:SetParent(optionsCanvas);
	optionsCanvas.OpacityCaption:SetPosition(10,optionsCanvas.ResetColors:GetTop()+optionsCanvas.ResetColors:GetHeight()+9);
	optionsCanvas.OpacityCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.OpacityCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsCanvas.OpacityCaption:SetForeColor(fontColor);
	optionsCanvas.OpacityCaption:SetText(Resource[language][71]..":");
	optionsCanvas.OpacityScrollbar=Turbine.UI.Lotro.ScrollBar();
	optionsCanvas.OpacityScrollbar:SetOrientation(Turbine.UI.Orientation.Horizontal);
	optionsCanvas.OpacityScrollbar:SetParent(optionsCanvas)
	optionsCanvas.OpacityScrollbar:SetPosition(optionsCanvas.OpacityCaption:GetLeft()+optionsCanvas.OpacityCaption:GetWidth()+5,optionsCanvas.OpacityCaption:GetTop());
	optionsCanvas.OpacityScrollbar:SetSize(optionsCanvas:GetWidth()-optionsCanvas.OpacityCaption:GetWidth()-optionsCanvas.OpacityCaption:GetLeft()-15,10);
	optionsCanvas.OpacityScrollbar:SetBackColor(Turbine.UI.Color(0,0,0));
	optionsCanvas.OpacityScrollbar:SetMinimum(0);
	optionsCanvas.OpacityScrollbar:SetMaximum(100);
	optionsCanvas.OpacityScrollbar.OriginalValue=100;
	optionsCanvas.OpacityScrollbar.ValueChanged=function()
		mapWindow.Map:SetOpacity(optionsCanvas.OpacityScrollbar:GetValue()/100);
	end

-- Load Minimized
	optionsCanvas.LoadMinimizedCB=Turbine.UI.Lotro.CheckBox();
	optionsCanvas.LoadMinimizedCB:SetParent(optionsCanvas);
	optionsCanvas.LoadMinimizedCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsCanvas.LoadMinimizedCB:SetForeColor(fontColor);
	optionsCanvas.LoadMinimizedCB:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.LoadMinimizedCB:SetPosition(10,optionsCanvas.OpacityCaption:GetTop()+optionsCanvas.OpacityCaption:GetHeight()+4);
	optionsCanvas.LoadMinimizedCB:SetText(Resource[language][17]);

-- Show Icon when Minimized
	optionsCanvas.ShowIconWhenMinimizedCB=Turbine.UI.Lotro.CheckBox();
	optionsCanvas.ShowIconWhenMinimizedCB:SetParent(optionsCanvas);
	optionsCanvas.ShowIconWhenMinimizedCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsCanvas.ShowIconWhenMinimizedCB:SetForeColor(fontColor);
	optionsCanvas.ShowIconWhenMinimizedCB:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.ShowIconWhenMinimizedCB:SetPosition(10,optionsCanvas.LoadMinimizedCB:GetTop()+optionsCanvas.LoadMinimizedCB:GetHeight()+4);
	optionsCanvas.ShowIconWhenMinimizedCB:SetText(Resource[language][18]);

-- Use 16x16 Icon
	optionsCanvas.UseMiniIconCB=Turbine.UI.Lotro.CheckBox();
	optionsCanvas.UseMiniIconCB:SetParent(optionsCanvas);
	optionsCanvas.UseMiniIconCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsCanvas.UseMiniIconCB:SetForeColor(fontColor);
	optionsCanvas.UseMiniIconCB:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.UseMiniIconCB:SetPosition(10,optionsCanvas.ShowIconWhenMinimizedCB:GetTop()+optionsCanvas.ShowIconWhenMinimizedCB:GetHeight()+4);
	optionsCanvas.UseMiniIconCB:SetText(Resource[language][201]);

-- Mini Icon is opaque
	optionsCanvas.MiniIconOpaqueCB=Turbine.UI.Lotro.CheckBox();
	optionsCanvas.MiniIconOpaqueCB:SetParent(optionsCanvas);
	optionsCanvas.MiniIconOpaqueCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsCanvas.MiniIconOpaqueCB:SetForeColor(fontColor);
	optionsCanvas.MiniIconOpaqueCB:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.MiniIconOpaqueCB:SetPosition(30,optionsCanvas.UseMiniIconCB:GetTop()+optionsCanvas.UseMiniIconCB:GetHeight()+4);
	optionsCanvas.MiniIconOpaqueCB:SetText(Resource[language][202]);

-- Show Quick Annotation control
	optionsCanvas.ShowQuickAnnotCB=Turbine.UI.Lotro.CheckBox();
	optionsCanvas.ShowQuickAnnotCB:SetParent(optionsCanvas);
	optionsCanvas.ShowQuickAnnotCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsCanvas.ShowQuickAnnotCB:SetForeColor(fontColor);
	optionsCanvas.ShowQuickAnnotCB:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.ShowQuickAnnotCB:SetPosition(10,optionsCanvas.MiniIconOpaqueCB:GetTop()+optionsCanvas.MiniIconOpaqueCB:GetHeight()+4);
	optionsCanvas.ShowQuickAnnotCB:SetText(Resource[language][160]);

	optionsCanvas.QAOpacityCaption=Turbine.UI.Label();
	optionsCanvas.QAOpacityCaption:SetParent(optionsCanvas);
	optionsCanvas.QAOpacityCaption:SetPosition(10,optionsCanvas.ShowQuickAnnotCB:GetTop()+optionsCanvas.ShowQuickAnnotCB:GetHeight()+9);
	optionsCanvas.QAOpacityCaption:SetSize(optionsCanvas:GetWidth()-301,18);
	optionsCanvas.QAOpacityCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsCanvas.QAOpacityCaption:SetForeColor(fontColor);
	optionsCanvas.QAOpacityCaption:SetText(Resource[language][161]..":");
	optionsCanvas.QAOpacityScrollbar=Turbine.UI.Lotro.ScrollBar();
	optionsCanvas.QAOpacityScrollbar:SetOrientation(Turbine.UI.Orientation.Horizontal);
	optionsCanvas.QAOpacityScrollbar:SetParent(optionsCanvas)
	optionsCanvas.QAOpacityScrollbar:SetPosition(optionsCanvas.QAOpacityCaption:GetLeft()+optionsCanvas.QAOpacityCaption:GetWidth()+5,optionsCanvas.QAOpacityCaption:GetTop());
	optionsCanvas.QAOpacityScrollbar:SetSize(optionsCanvas:GetWidth()-optionsCanvas.QAOpacityCaption:GetWidth()-optionsCanvas.QAOpacityCaption:GetLeft()-15,10);
	optionsCanvas.QAOpacityScrollbar:SetBackColor(Turbine.UI.Color(0,0,0));
	optionsCanvas.QAOpacityScrollbar:SetMinimum(0);
	optionsCanvas.QAOpacityScrollbar:SetMaximum(100);
	optionsCanvas.QAOpacityScrollbar.OriginalValue=15;
	optionsCanvas.QAOpacityScrollbar.ValueChanged=function()
		quickWindow:SetOpacity(optionsCanvas.QAOpacityScrollbar:GetValue()/100);
	end

-- Other Options ?
	optionsCanvas.WaypointCB=Turbine.UI.Lotro.CheckBox();
	optionsCanvas.WaypointCB:SetParent(optionsCanvas);
	optionsCanvas.WaypointCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsCanvas.WaypointCB:SetForeColor(fontColor);
	optionsCanvas.WaypointCB:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.WaypointCB:SetPosition(10,optionsCanvas.QAOpacityCaption:GetTop()+optionsCanvas.QAOpacityCaption:GetHeight()+4);
	optionsCanvas.WaypointCB:SetText(Resource[language][212]);

	optionsCanvas.WaypointMsg=Turbine.UI.Label();
	optionsCanvas.WaypointMsg:SetParent(optionsCanvas);
	optionsCanvas.WaypointMsg:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsCanvas.WaypointMsg:SetForeColor(fontColor);
	optionsCanvas.WaypointMsg:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.WaypointMsg:SetPosition(10,optionsCanvas.WaypointCB:GetTop());
	optionsCanvas.WaypointMsg:SetText(Resource[language][213]);

	optionsCanvas.DebugCB=Turbine.UI.Lotro.CheckBox();
	optionsCanvas.DebugCB:SetParent(optionsCanvas);
	optionsCanvas.DebugCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	optionsCanvas.DebugCB:SetForeColor(fontColor);
	optionsCanvas.DebugCB:SetSize(optionsCanvas:GetWidth()-15,18);
	optionsCanvas.DebugCB:SetPosition(10,optionsCanvas.WaypointCB:GetTop()+optionsCanvas.WaypointCB:GetHeight()+4);
	optionsCanvas.DebugCB:SetText(Resource[language][211]);

--** SAVE AND CANCEL
	optionsCanvas.SaveButton=Turbine.UI.Lotro.Button();
	optionsCanvas.SaveButton:SetParent(optionsCanvas);
	optionsCanvas.SaveButton:SetSize(100,20);
	optionsCanvas.SaveButton:SetPosition(20,optionsCanvas:GetHeight()-57);
	optionsCanvas.SaveButton:SetText(Resource[language][11]);
	optionsCanvas.SaveButton.Click=function()
		local hasError=false;
		-- validate option values

		if hasError then
			optionsCanvas.ErrorLabel:SetVisible(true);
			optionsCanvas.HadErrors=true;
			optionsCanvas.ErrorFadeTime=Turbine.Engine:GetGameTime()+3;
			optionsCanvas:SetWantsUpdates(true);
		else
			debug=optionsCanvas.DebugCB:IsChecked();
			EnableWaypoint=optionsCanvas.WaypointCB:IsChecked();
			if debug then debugWindow:SetVisible(true) end
			rb=optionsCanvas.LoadMinimizedCB:IsChecked();
			mapWindow:SetLoadMinimized(rb);
			rb=optionsCanvas.ShowIconWhenMinimizedCB:IsChecked();
			mapWindow:SetShowIconWhenMinimized(rb);
			minWindow:SetUseMiniIcon(optionsCanvas.UseMiniIconCB:IsChecked());
			minWindow:SetMiniIconOpaque(optionsCanvas.MiniIconOpaqueCB:IsChecked());
			quickWindow.Displayed=optionsCanvas.ShowQuickAnnotCB:IsChecked();
			quickWindow:SetVisible(quickWindow.Displayed);
			quickWindow.Opacity=optionsCanvas.QAOpacityScrollbar:GetValue()/100;

			fontColor=optionsCanvas.FontColor:GetColor();
			trimColor=optionsCanvas.TrimColor:GetColor();
			backColor=optionsCanvas.BackColor:GetColor();
			headingsColor=optionsCanvas.HeadingsColor:GetColor();
			listTextColor=optionsCanvas.ListTextColor:GetColor();

			local newLanguage=optionsCanvas.LanguageList:GetValue();

			mapWindow:SetFontColor();
			mapWindow:SetTrimColor();
			mapWindow:SetBackColor();
			mapWindow:SetHeadingsColor();
			mapWindow:SetLanguage();
			mapWindow:SetListTextColor();

			local newWorldName=optionsCanvas.WorldList:GetValue();
			defaultMap=optionsCanvas.DefaultMapList:GetValue();
			if newLanguage~=language or (worldName~=newWorldName and mapWindow.CurrentMapID==1) then
				language=newLanguage;
				worldName=newWorldName;
				mapWindow.PreserveMapID=true;
				-- load the plugin that will unload and reload this plugin (we can only read the annotation files without a 15 second delay while we are "loading")
				Turbine.PluginManager.LoadPlugin("MoorMapLoader");
			else
				worldName=newWorldName;
				annotWindow:SetLanguage();
				annotWindow:LoadAnnotationList(); -- force reload of the translated values
				mapWindow.Map.IconSearch.OldText=tostring(mapWindow.Map.IconSearch.OldText).."X"; -- any change to the old text will force a refresh in case there was a filter applied
				mapWindow.NeedsRefresh=true;
				mapWindow:SetWantsUpdates(true); -- will reload all map components, including icon search list
			end
		end
	end

	optionsCanvas.CancelButton=Turbine.UI.Lotro.Button();
	optionsCanvas.CancelButton:SetParent(optionsCanvas);
	optionsCanvas.CancelButton:SetSize(100,20);
	optionsCanvas.CancelButton:SetPosition(optionsCanvas:GetWidth()-20-optionsCanvas.CancelButton:GetWidth(),optionsCanvas:GetHeight()-57);
	optionsCanvas.CancelButton:SetText(Resource[language][12]);
	optionsCanvas.CancelButton.Click=function()
		mapWindow.Map:SetOpacity(optionsCanvas.OpacityScrollbar.OriginalValue);
		quickWindow:SetOpacity(optionsCanvas.QAOpacityScrollbar.OriginalValue);
		optionsCanvas.FontColor:SetColor(fontColor);
		optionsCanvas.TrimColor:SetColor(trimColor);
		optionsCanvas.BackColor:SetColor(backColor);
		optionsCanvas.HeadingsColor:SetColor(headingsColor);
	end

	optionsCanvas.ErrorLabel=Turbine.UI.Label();
	optionsCanvas.ErrorLabel:SetParent(optionsCanvas);
	optionsCanvas.ErrorLabel:SetText("Adjusted Invalid Values")
	optionsCanvas.ErrorLabel:SetPosition(optionsCanvas.SaveButton:GetLeft()+optionsCanvas.SaveButton:GetWidth(),optionsCanvas.SaveButton:GetTop());
	optionsCanvas.ErrorLabel:SetSize(optionsCanvas.CancelButton:GetLeft()-(optionsCanvas.ErrorLabel:GetLeft()),optionsCanvas.SaveButton:GetHeight());
	optionsCanvas.ErrorLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
	optionsCanvas.ErrorLabel:SetForeColor(Turbine.UI.Color(1,0,0));
	optionsCanvas.ErrorLabel:SetVisible(false);
	optionsCanvas.ErrorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

	optionsCanvas.DefaultMapList:SetZOrder(optionsCanvas.ErrorLabel:GetZOrder()+1)
	optionsCanvas.WorldList:SetZOrder(optionsCanvas.DefaultMapList:GetZOrder()+1);
	optionsCanvas.LanguageList:SetZOrder(optionsCanvas.WorldList:GetZOrder()+1);

	optionsCanvas.Update=function(sender,args)
		if optionsCanvas.HadErrors then
			if Turbine.Engine:GetGameTime()>optionsCanvas.ErrorFadeTime then
				optionsCanvas:SetWantsUpdates(false);
				optionsCanvas.ErrorLabel:SetVisible(false);
				optionsCanvas.HadErrors=false
			end
		end
	end
	optionsCanvas.SetTrimColor=function(sender,color)
		optionsCanvas.LanguageList:SetBorderColor(color);
		optionsCanvas.FontColor:SetTrimColor(color);
		optionsCanvas.TrimColor:SetTrimColor(color);
		optionsCanvas.BackColor:SetTrimColor(color);
		optionsCanvas.HeadingsColor:SetTrimColor(color);
		optionsCanvas.ListTextColor:SetTrimColor(color);
	end
	optionsCanvas.SetBackColor=function(sender,color)
		optionsCanvas.LanguageList:SetBackColor(color);
		optionsCanvas.LanguageList:SetCurrentBackColor(color);
		optionsCanvas:SetBackColor(color);
		optionsCanvas.FontColor:SetBackColor(color);
		optionsCanvas.TrimColor:SetBackColor(color);
		optionsCanvas.BackColor:SetBackColor(color);
		optionsCanvas.HeadingsColor:SetBackColor(color);
		optionsCanvas.ListTextColor:SetBackColor(color);
	end
	optionsCanvas.SetFontColor=function(sender,color)
		optionsCanvas.LanguageCaption:SetForeColor(color);
		optionsCanvas.WorldCaption:SetForeColor(color);
		optionsCanvas.DefaultMapCaption:SetForeColor(color);
		optionsCanvas.LoadMinimizedCB:SetForeColor(color);
		optionsCanvas.ShowIconWhenMinimizedCB:SetForeColor(color);
		optionsCanvas.UseMiniIconCB:SetForeColor(color);
		optionsCanvas.MiniIconOpaqueCB:SetForeColor(color);
		optionsCanvas.TrimCaption:SetForeColor(color);
		optionsCanvas.FontCaption:SetForeColor(color);
		optionsCanvas.BackCaption:SetForeColor(color);
		optionsCanvas.HeadingsCaption:SetForeColor(color);
		optionsCanvas.ListTextCaption:SetForeColor(color);
		optionsCanvas.OpacityCaption:SetForeColor(color);
	end
	optionsCanvas.SetHeadingsColor=function(sender,color)
		optionsCanvas.OptionsCaption:SetForeColor(color);
	end
	optionsCanvas.SetListTextColor=function(sender,color)
		optionsCanvas.LanguageList:SetTextColor(color);
	end

	optionsCanvas.SetLanguage=function(sender,tmpLanguage)
		optionsCanvas.OptionsCaption:SetText(Resource[tmpLanguage][4]..":");
		optionsCanvas.LanguageCaption:SetText(Resource[tmpLanguage][5]..":");
		optionsCanvas.WorldCaption:SetText(Resource[tmpLanguage][149]..":");
		optionsCanvas.DefaultMapCaption:SetText(Resource[tmpLanguage][200]..":");
		optionsCanvas.TrimCaption:SetText(Resource[tmpLanguage][6]..":");
		optionsCanvas.BackCaption:SetText(Resource[tmpLanguage][7]..":");
		optionsCanvas.FontCaption:SetText(Resource[tmpLanguage][8]..":");
		optionsCanvas.HeadingsCaption:SetText(Resource[tmpLanguage][15]..":");
		optionsCanvas.ListTextCaption:SetText(Resource[tmpLanguage][16]..":");
		optionsCanvas.ResetColors:SetText(Resource[tmpLanguage][9]);
		optionsCanvas.OpacityCaption:SetText(Resource[tmpLanguage][71]..":");

		optionsCanvas.LoadMinimizedCB:SetText(Resource[tmpLanguage][17]);
		optionsCanvas.ShowIconWhenMinimizedCB:SetText(Resource[tmpLanguage][18]);
		optionsCanvas.UseMiniIconCB:SetText(Resource[tmpLanguage][201]);
		optionsCanvas.MiniIconOpaqueCB:SetText(Resource[tmpLanguage][202]);
		optionsCanvas.ShowQuickAnnotCB:SetText(Resource[tmpLanguage][160]);
		optionsCanvas.QAOpacityCaption:SetText(Resource[tmpLanguage][161]..":");
		optionsCanvas.WaypointCB:SetText(Resource[tmpLanguage][212]);
		optionsCanvas.DebugCB:SetText(Resource[tmpLanguage][211]);

		optionsCanvas.SaveButton:SetText(Resource[tmpLanguage][11]);
		optionsCanvas.CancelButton:SetText(Resource[tmpLanguage][12]);
	end

	-- refresh the options status to reflect current values
	optionsCanvas.OpacityScrollbar:SetValue(math.floor(mapWindow.Map:GetOpacity()*100));
	optionsCanvas.OpacityScrollbar.OriginalValue=mapWindow.Map:GetOpacity();
	optionsCanvas.QAOpacityScrollbar:SetValue(math.floor(quickWindow:GetOpacity()*100));
	optionsCanvas.QAOpacityScrollbar.OriginalValue=quickWindow:GetOpacity();
	optionsCanvas.LoadMinimizedCB:SetChecked(mapWindow:GetLoadMinimized());
	optionsCanvas.ShowIconWhenMinimizedCB:SetChecked(mapWindow:GetShowIconWhenMinimized());
	optionsCanvas.UseMiniIconCB:SetChecked(minWindow:GetUseMiniIcon());
	optionsCanvas.MiniIconOpaqueCB:SetChecked(minWindow:GetMiniIconOpaque());
	optionsCanvas.ShowQuickAnnotCB:SetChecked(quickWindow.Displayed);
	optionsCanvas.WaypointCB:SetChecked(EnableWaypoint);
	optionsCanvas.DebugCB:SetChecked(debug);

	local index;
	for index=1,optionsCanvas.LanguageList.ListData:GetItemCount() do
		if optionsCanvas.LanguageList.ListData:GetItem(index):GetValue()==language then
			optionsCanvas.LanguageList:SetSelectedIndex(index);
			break;
		end
	end
	for index=1,optionsCanvas.WorldList.ListData:GetItemCount() do
		if optionsCanvas.WorldList.ListData:GetItem(index).DataValue==worldName then
			optionsCanvas.WorldList:SetSelectedIndex(index);
			break;
		end
	end
	for index=1,optionsCanvas.DefaultMapList.ListData:GetItemCount() do
		if optionsCanvas.DefaultMapList.ListData:GetItem(index):GetValue()==defaultMap then
			optionsCanvas.DefaultMapList:SetSelectedIndex(index);
			break;
		end
	end
	optionsCanvas:SetLanguage(language);

	optionsPanel.HScroll=Turbine.UI.Lotro.ScrollBar();
	optionsPanel.HScroll:SetOrientation(Turbine.UI.Orientation.Horizontal);
	optionsPanel.HScroll:SetParent(optionsPanel);
	optionsPanel.HScroll:SetBackColor(backColor);
	optionsPanel.HScroll:SetPosition(0,optionsPanel:GetHeight()-12);
	optionsPanel.HScroll:SetWidth(optionsPanel:GetWidth()-12);
	optionsPanel.HScroll:SetHeight(12);
	optionsPanel.HScroll:SetVisible(false);
--	optionsViewPane:SetHorizontalScrollBar(optionsPanel.HScroll);
	optionsPanel.HScroll:SetMaximum(optionsCanvas:GetWidth()-optionsViewPane:GetWidth());
	optionsPanel.HScroll.ValueChanged=function()
		optionsCanvas:SetLeft(0-optionsPanel.HScroll:GetValue())
	end
	
	optionsPanel.VScroll=Turbine.UI.Lotro.ScrollBar();
	optionsPanel.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
	optionsPanel.VScroll:SetParent(optionsPanel);
	optionsPanel.VScroll:SetBackColor(backColor);
	optionsPanel.VScroll:SetPosition(optionsPanel:GetWidth()-12,0);
	optionsPanel.VScroll:SetHeight(optionsPanel:GetHeight()-12);
	optionsPanel.VScroll:SetWidth(12);
	optionsPanel.VScroll:SetVisible(false);
--	optionsViewPane:SetVerticalScrollBar(optionsPanel.VScroll);
	optionsPanel.VScroll:SetMaximum(optionsCanvas:GetHeight()-optionsViewPane:GetHeight());
	optionsPanel.VScroll.ValueChanged=function()
		optionsCanvas:SetTop(0-optionsPanel.VScroll:GetValue())
	end

	optionsPanel.SizeChanged=function()
		optionsViewPane:SetWidth(optionsPanel:GetWidth()-12);
		optionsViewPane:SetHeight(optionsPanel:GetHeight()-12);
		optionsPanel.HScroll:SetTop(optionsPanel:GetHeight()-12);
		optionsPanel.HScroll:SetWidth(optionsPanel:GetWidth()-12);
		optionsPanel.VScroll:SetLeft(optionsPanel:GetWidth()-12);
		optionsPanel.VScroll:SetHeight(optionsPanel:GetHeight()-12);
		local max=optionsCanvas:GetHeight()-optionsViewPane:GetHeight();
		if max>0 then
			optionsPanel.VScroll:SetMaximum(max);
			optionsPanel.VScroll:SetVisible(true);
		else
			optionsPanel.VScroll:SetVisible(false);
		end
		max=optionsCanvas:GetWidth()-optionsViewPane:GetWidth();
		if max>0 then
			optionsPanel.HScroll:SetMaximum(max);
			optionsPanel.HScroll:SetVisible(true);
		else
			optionsPanel.HScroll:SetVisible(false);
		end
	end

	plugin.GetOptionsPanel = function( self )
		return optionsPanel;
	end

	optionsWindow=Turbine.UI.Lotro.Window()
	optionsWindow:SetSize(520,642); -- canvas size+5 pixel vertival border and 45 pixel horizontal border
	optionsWindow:SetZOrder(2);
	optionsWindow.VisibleChanged=function()
		if not optionsWindow:IsVisible() then
			optionsCanvas:SetParent(optionsViewPane); -- put it back in the Plugin Manager
		end
	end
	optionsBorder=Turbine.UI.Control();
	optionsBorder:SetParent(optionsWindow);
	optionsBorder:SetSize(522,539);
	optionsBorder:SetPosition(5,45);
	optionsPanel:SetParent(optionsBorder);
